require "import"
import "android.content.Intent"
import "android.net.Uri"
import "android.view.View"
import "android.widget.Button"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "com.androlua.LuaDialog"



function pasteDictFunc()
local text=[[if service.plugin("الإملاء المريح",node) return true end return true]]
service.setText(text)
return true
end




function updateApiKey()
  -- التأكد من وجود المجلد والملف
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/gemini.txt"
io.mkdir("/storage/emulated/0/Documents/")
  io.mkdir("/storage/emulated/0/Documents/comfortableDictation")
  io.open(file_path, "a"):close()

  local dlg = LuaDialog()
  local edit = loadlayout{
    EditText,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "مفتاح Gemini الجديد"
  }
  edit.setBackgroundColor(0xFF00008B)

  -- قراءة المفتاح الحالي (إن وُجد)
  local current_key = "غير معروف"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    if content ~= "" then
      current_key = content
    end
    file_read:close()
  end

  dlg.setTitle("تحديث مفتاح Gemini")
  dlg.setMessage("المفتاح الحالي:\n" .. current_key)
  dlg.setView(edit)
  edit.setContentDescription("أدخل مفتاح Gemini الجديد هنا، ثم تحقق منه عبر التمرير للأسفل أو للأعلى.")

  dlg.setButton("حفظ", function()
    local new_key = tostring(edit.getText())
    if new_key and new_key ~= "" then
      local f = io.open(file_path, "w")
      if f then
        f:write(new_key .. "\n")
        f:close()

        local successDialog = LuaDialog(service)
        successDialog.setTitle("تم تحديث مفتاح Gemini")
        successDialog.setMessage("تم حفظ المفتاح:\n" .. new_key)
        successDialog.setCancelable(false)
        successDialog.setOnKeyListener(luajava.createProxy("android.content.DialogInterface$OnKeyListener", {
          onKey = function(d, keyCode, event)
            if keyCode == 4 then
              service.speak("اضغط على موافق للتنفيذْ، أو على إعادة المحاولة لإدخال المفتاح مجددًا")
              return true
            end
            return false
          end
        }))
        successDialog.setPositiveButton("موافق", function() os.exit(0) end)
        successDialog.setNegativeButton("إعادة المحاولة", function() updateApiKey() end)
        successDialog.show()
      else
        LuaDialog()
          .setTitle("خطأ في الكتابة")
          .setMessage("تعذر فتح الملف للكتابة.")
          .setPositiveButton("موافق", function() end)
          .show()
      end
    else
      LuaDialog()
        .setTitle("تنبيه")
        .setMessage("الرجاء إدخال مفتاح جديد")
        .setPositiveButton("إعادة المحاولة", function() updateApiKey() end)
        .show()
    end
  end)

  dlg.setNegativeButton("إلغاء", function() dlg.dismiss() end)
dlg.setButton3("الحصول على مفتاح جديد", function()
local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)end)
  dlg.show()
end





function updatePasswordBaridiMob()
-- التأكد من وجود المجلد والملف
local file_path = "/storage/emulated/0/Documents/comfortableDictation/baridiMob.txt"
io.mkdir("/storage/emulated/0/Documents/comfortableDictation")
io.open(file_path, "a"):close()
  local dlg = LuaDialog()
  local edit = loadlayout{
    EditText,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "كلمة المرور الجديدة"
  }
  edit.setBackgroundColor(0xFF00008B)

  -- قراءة كلمة المرور الحالية (إن وُجدت)
  local current_password = "غير معروفة"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    if content ~= "" then
      current_password = content
    end
    file_read:close()
  end

  dlg.setTitle("تحديث كلمة المرور")
  dlg.setMessage("كلمة المرور الحالية:\n" .. current_password)
  dlg.setView(edit)
  edit.setContentDescription("أدخل كلمة المرور الجديدة هنا, ثم تحقق منها عبر التمرير للأسفل أو للأعلى.")

  dlg.setButton("حفظ", function()
    local new_password = tostring(edit.getText())
    if new_password and new_password ~= "" then
      local f = io.open(file_path, "w")
      if f then
        f:write(new_password .. "\n")
        f:close()

        local successDialog = LuaDialog(service)
        successDialog.setTitle("تم تحديث كلمة المرور")
        successDialog.setMessage("تم حفظ كلمة المرور:\n" .. new_password)
        successDialog.setCancelable(false)
        successDialog.setOnKeyListener(luajava.createProxy("android.content.DialogInterface$OnKeyListener", {
          onKey = function(d, keyCode, event)
            if keyCode == 4 then
              service.speak("اضغط على موافق للتنفيذْ, أو على إعادة المحاولة لإدخال كلمة المرور مجدداً")
              return true
            end
            return false
          end
        }))
        successDialog.setPositiveButton("موافق", function() os.exit(0) end)
        successDialog.setNegativeButton("إعادة المحاولة", function() updatePasswordBaridiMob() end)
        successDialog.show()
      else
        LuaDialog()
          .setTitle("خطأ في الكتابة")
          .setMessage("تعذر فتح الملف للكتابة.")
          .setPositiveButton("موافق", function() end)
          .show()
      end
    else
      LuaDialog()
        .setTitle("تنبيه")
        .setMessage("الرجاء إدخال كلمة مرور جديدة")
        .setPositiveButton("إعادة المحاولة", function() updatePasswordBaridiMob() end)
        .show()
    end
  end)

  dlg.setNegativeButton("إلغاء", function() dlg.dismiss() end)
  dlg.show()
end








layout = {
  LinearLayout,
  orientation = "vertical",
  {
    TextView,
    text = "حلول مشاكل الإملاء المريح",
    id = "title",
    layout_width = "fill",
  },
  {
    Button,
    layout_width = "fill",
    text = "تخصيص إيماءة للإملاء المريح.",
    onClick = function()
d.dismiss()
service.click({{"%操作设置","paramètres du thème des gestes*|تَخْصِيصُ الإِيماءات*|Gesture schemes settings*>10$100","Plus d'options|المزيد من الخيارات|More options>10$100","Créer une fonction|إنشاء وظيفة*|Create a new function>10$100","%输入/الإملاء المريح$300","#button1$200","%Effacer le texte$700","%pasteDictFunc$400", "SAUVEGARDER|حِفْظ|SAVE$300","%Retour","%朗读/والآن اختر الإيماءة المناسِبة, ثم بعد ذلك اختر  الإملاء المريح.",}})
    end
  },
  {
    Button,
    layout_width = "fill",
    text = "تحديث المفتاح",
    onClick = function()
d.dismiss()
updateApiKey()
    end
  },
  {
    Button,
    layout_width = "fill",
    text = "استخدام المفتاح العام .",
    onClick = function()
d.dismiss()
local textGemini =[[AIzaSyA70wke7JY_W2DQsv87Y8sCBpQkcK7jCi8]]
io.mkdir("/storage/emulated/0/Documents/comfortableDictation")
io.open("/storage/emulated/0/Documents/comfortableDictation/gemini.txt", "w+")
:write(textGemini)
:close()
    end
  },
  {
    Button,
    layout_width = "fill",
    text = "إنشاء مفتاح جديد من الموقع",
    onClick = function()
d.dismiss()
local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)
    end
  },
  {
    Button,
    layout_width = "fill",
    text = "تحديث كلمة المرور BaridiMob.",
    onClick = function()
d.dismiss()
updatePasswordBaridiMob()
    end
  },
  {
    Button,
    layout_width = "fill",
    text = "خروج",
    onClick = function()
d.dismiss()
    end
  },
}

d = LuaDialog(this)
d.View = loadlayout(layout)
d.show()
return true